#include <stdio.h>
#include <stdlib.h>

/*STRUKTUURI KIRJELDUS*/
struct nimistu_element {
       int number;
       struct nimistu_element * jrgm_element;
};

/*TPIDE KIRJELDUS*/
/*UUS TP NIMEGA element*/
typedef struct nimistu_element element;

/*UUS TP NIMEGA viit_elemendile*/
typedef element *viit_elemendile;
/*FUNKTSIOONIDE PROTOTBID*/
void push(viit_elemendile *viit_esimesele, int info);
int pop(viit_elemendile *viit_esimesele);
int onTyhi(viit_elemendile viit_esimesele);
void trykiStack(viit_elemendile viit_aktiivsele);
void menyy (void);

int main (void)
{
    /*VIIT STACKI TIPULE*/
    viit_elemendile viit_stackile=NULL;
    /*KASUTAJA VALIK MENS*/
    int valik;
    /*KASUTAJA POOLT SISESTATUD VRTUS*/
    int vaartus;
    
    /*VLJASTAME VALIKUTDEGA MEN*/
    menyy();
    printf("Sisesta oma valik: ");
    
    /*KASUTAJA SISESTAB VALIKU*/
    scanf("%d", &valik);
    
    /*KUNI KASUTAJA VALIB 3 EHK PROGRAMMI LPETAMISE*/
    while(valik!=3)
    {              
      switch (valik)
      {
             /*KASUTAJA VALIS 1, LISAME VRTUSE STACKI*/
             case 1:
                  printf("Sisesta tisarv: ");
                  scanf("%d", &vaartus);
                  push(&viit_stackile, vaartus);
                  trykiStack(viit_stackile);
                  break;
             
             /*KASUTAJA VALIS 2, "LKKAME" HE VRTUSE STACKIST VLJA*/     
             case 2:
                  /*KONTROLLIME EGA STACK THI EI OLE*/
                  if(!onTyhi(viit_stackile))
                  {
                     printf("Vtame stackist andmed: %d\n", pop (&viit_stackile));
                  }
                  trykiStack(viit_stackile);
                  break;
                  
             /*KASUTAJA TEGI OLEMATU VALIKU*/
             default:
                  printf("Sellist valikut ei ole!\n");
                  menyy();
                  break;
      } /*SWITCH LPP*/           
      
      printf("\n Sisesta uus valik: ");
      scanf("%d", &valik);
   } /*WHILE LPP*/                                              
   
   printf("Programmi lpp\n\n");
   
   return 0;
}

/*MEN - VLJASTAME KASUTAJALE VIMALIKUD VALIKUD*/
void menyy(void)
{
     printf("\n Tee oma valik:\n  1: vruse lisamine stacki (push)\n  2: vrtuse vtmine stackist (pop)\n  3: programmi lpp\n");
}

/*LISAME ANDMED STACKI*/        
void push(viit_elemendile *viit_esimesele, int info)
{
     /*VIIT UUELE ELEMENDILE*/
     viit_elemendile uus_viit;
     
     /*ERALDAME MLU*/
     uus_viit=malloc(sizeof(element));
     
     /*LISAME UUE ELEMENDI STACKI "PEALE"*/
     if (uus_viit!=NULL)
     {
         /*LISAME ANDMED*/
         uus_viit -> number = info;

         /*UUENDAME VIITADE VRTUSI*/
         uus_viit -> jrgm_element = *viit_esimesele;
         *viit_esimesele = uus_viit;
     }
}

int pop (viit_elemendile *viit_esimesele)
{
    /*KASUTAME SEDA VIITA AJUTISELT*/
    viit_elemendile abi_viit;
    
    /*VRTUS, MILLE ME EEMALDAME STACKIST*/
    int pop_vaartus;
    
    abi_viit = *viit_esimesele;
    pop_vaartus=(*viit_esimesele)->number;
    *viit_esimesele=(*viit_esimesele)->jrgm_element;
    
    /*VABASTAME LELIIGSE MLU*/
    free (abi_viit);
    
    return pop_vaartus;
}

/*STACKI VLJASTAMINE*/    
void trykiStack(viit_elemendile viit_aktiivsele)
{
     /*KONTROLLIME KAS STACK ON THI*/
     if(viit_aktiivsele == NULL)
     {
             printf("Stack on tyhi \n\n");
     }
     else
     
     while (viit_aktiivsele !=NULL)
     {
           printf("%d -->", viit_aktiivsele->number);
           viit_aktiivsele=viit_aktiivsele ->jrgm_element;
     }
     
     printf("NULL\n");
     
}

/*KUI STACK ON TYHI, TAGASTAME 1; KUI EI OLE THI TAGASTAME 0*/
int onTyhi(viit_elemendile viit_esimesele)
{
    /*KONTROLLIME KAS VIIDA VRTUS ON "NULL"*/
    return viit_esimesele == NULL;
}     
